]> git.plutz.net Git - blast/commitdiff
module for smb and nis login setup
authorPaul Hänsch <paul@plutz.net>
Sun, 21 Jul 2019 18:11:39 +0000 (20:11 +0200)
committerPaul Hänsch <paul@plutz.net>
Sun, 21 Jul 2019 18:11:39 +0000 (20:11 +0200)
config.example
modules/smb_nis.mk [new file with mode: 0644]

index 6574d0ccb76dae4e56ecdcb68a3cccdc725385dc..95d14853162fa1a0f9d23ede36b3827e090a6818 100644 (file)
@@ -49,6 +49,9 @@
 ## Rotation for some Raspberry Displays
 # display_rotate=0
 
 ## Rotation for some Raspberry Displays
 # display_rotate=0
 
+## When using NIS modules the directory server should be given
+# nis_server=nismaster
+
 ## If the approxmodule is enabled, then one (and only one) apt-source
 ## can be choosen to install packages from
 ## See modules/approx.mk if you need more flexibility
 ## If the approxmodule is enabled, then one (and only one) apt-source
 ## can be choosen to install packages from
 ## See modules/approx.mk if you need more flexibility
diff --git a/modules/smb_nis.mk b/modules/smb_nis.mk
new file mode 100644 (file)
index 0000000..a940d1d
--- /dev/null
@@ -0,0 +1,61 @@
+PACKAGES += cifs-utils libpam-mount libpam-script lxdm nis nscd samba-common-bin usermode
+
+ifndef nis_server
+  nis_server := nismaster
+endif
+
+define DEBCONF +=
+
+nis    nis/domain      string  .${nis_server}
+endef
+
+export smb_nis_pamscript smb_nis_pammount
+
+define smb_nis_pamscript :=
+#!/bin/sh
+
+/bin/bash -c '
+  printf "%s\n" "$$PAM_OLDAUTHTOK" "$$PAM_AUTHTOK" "$$PAM_AUTHTOK" \
+  | smbpasswd -sr ${nis_server} -U "$$PAM_USER"
+'
+
+exit $?
+
+endef
+
+define smb_nis_pammount :=
+<pam_mount> <debug enable="0" />
+  <!-- Volume definitions -->
+  <volume options="user=%(USER)" fstype="cifs" server="${nis_server}"     path="%(USER)" mountpoint="~" />
+  <mntoptions require="nosuid,nodev" />
+  <logout wait="0" hup="no" term="no" kill="no" />
+  <mkmountpoint enable="1" remove="true" />
+</pam_mount>
+
+endef
+
+.PHONY: _smb_nis
+_config: _smb_nis
+
+_smb_nis: ${CFGROOT}/opt/pam_script/pam_script_passwd ${CFGROOT}/etc/security/pam_mount.conf.xml
+_smb_nis: ${CFGROOT}/etc/yp.conf ${CFGROOT}/etc/defaultdomain
+
+_smb_nis: ${CFGROOT}
+       sed -Ei 's;^(passwd:|group:|shadow:|gshadow:) *;\1      nis ;' $${CFGROOT}/etc/nsswitch.conf
+       printf '\nauth          optional        pam_mount.so\n' >>$${CFGROOT}/etc/pam.d/common-auth
+       printf '\nsession       optional        pam_mount.so\n' >>$${CFGROOT}/etc/pam.d/common-session
+       printf '\npassword      required        pam_script.so dir=/opt/pam_script\n'  >$${CFGROOT}/etc/pam.d/common-password
+
+${CFGROOT}/opt/pam_script/pam_script_passwd: ${CFGROOT}
+       mkdir -p "$(dir $@)"
+       printf '%s' "$${smb_nis_pamscript}" >"$@"
+
+${CFGROOT}/etc/security/pam_mount.conf.xml: ${CFGROOT}
+       mkdir -p "$(dir $@)"
+       printf '%s' "$${smb_nis_pammount}" >"$@"
+
+${CFGROOT}/etc/yp.conf: ${CFGROOT}
+       printf 'ypserver        %s\n' "${nis_server}" >"$@"
+
+${CFGROOT}/etc/defaultdomain: ${CFGROOT}
+       printf '.%s\n' "${nis_server}" >"$@"